<?php
namespace App\Http\Controllers\Admin;
use App\Http\Controllers\AuthController;
use App\Http\Requests\AdminMenu\CreateOrUpdateRequsest;
use App\Http\Result\ApiRst;
use App\Model\AdminMenu;

use Illuminate\Http\Request;

/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2020/3/19 0019
 * Time: 13:48
 */

class AdminMenuController extends AuthController
{
    public function index(Request $request)
    {

        $menu = AdminMenu::query()
            ->orderBy('sequence', 'asc')
            ->get()->toArray();

        $menuList = $this->buildMenuChild(1, $menu);

        return ApiRst::response($menuList);
    }

    private function buildMenuChild($pid, $menuList){
        $treeList = [];
        foreach ($menuList as $v) {

            if ($pid == $v['parent_id']) {
                $node = (array)$v;
                $child = $this->buildMenuChild($v['id'], $menuList);
                if (!empty($child)) {
                    $node['children'] = $child;
                }
                // todo 后续此处加上用户的权限判断
                $treeList[] = $node;
            }
        }
        return $treeList;
    }

    public function destroy(Request $request)
    {

        $Admin_menu = AdminMenu::query()->findOrFail($request->get('id'));

        if(!$Admin_menu) throw new \Exception(json_encode($Admin_menu));

        if(AdminMenu::query()->where('parent_id',$Admin_menu->id)->count()) {
            return ApiRst::response('DELETE_PARENT_NODE');
        };
        $Admin_menu->delete();
        return ApiRst::response(['is_success'=>1]);
    }

    public function store(Request $requsest)
    {

//        dd($requsest->all());
        $res = AdminMenu::create($requsest->all());
        return ApiRst::response(['is_success'=>1]);
    }

    public function edit($id)
    {
       $data= AdminMenu::query()->findOrFail($id);

       return ApiRst::response($data);
    }


    public function update(Request $requset)
    {
        $data = AdminMenu::query()->findOrFail($requset->post('id'));
        $field_name = $requset->post('field_name');
        $value = $requset->post('value');


       $res= $data->update([$field_name=>$value]);

        if(!$res) throw new \Exception('参数错误');

        return ApiRst::response(['is_success'=>1]);
    }

}