<?php
namespace App\Http\Controllers\Admin;
use App\Http\Controllers\AuthController;
use App\Http\Result\ApiRst;
use App\Model\IndexNews;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class IndexNewsController extends AuthController
{
    public function index(Request $request)
    {
        IndexNews::create($request->all());
        return ApiRst::response(['is_success'=>1]);
    }

    public function upload_cover_img(Request $request)
    {
       $file = $request->file('cover_img');
        if($file && $file->isValid()){
        //获取原图片信息
            $ext = $file->getClientOriginalExtension();
            $originalName = $file->getClientOriginalName();
            $type = $file->getClientMimeType();
            $path = $file->getRealPath();
            //验证图片类型，大小等
            //保存图片
            $save_name = date('YmdHis',time()) .'-' .uniqid() .'.'. $ext;
            $bool = Storage::disk('uploads')->put($save_name,file_get_contents($path));
            if(!$bool){
                return ApiRst::response('SYS_ERR');
            }
        }else{
            return ApiRst::response('CHOOSE_FILE');
        }
        //如果验证通过，则继续执行下面的代码
        $data = $request->input('Student');
        //图片全路径
        $img_web_path = storage_path('app/uploads') . '/' .$save_name;
        //图片相对路径
        $data['headimg'] = $save_name;
        return ApiRst::response(['is_success'=>1,'src'=>$img_web_path]);
       /* if(Student::create($data)){
            return redirect('Student/index')->with('success','添加成功');
        }else{
            return redirect()->back();
        }*/
    }

}