<?php
namespace App\Http\Controllers\Index;
use App\Http\Controllers\Controller;
use App\Listeners\browserModel;
use Moell\LayuiAdmin\Models\ArticleInfo;
use Illuminate\Http\Request;
use App\Enum\NewsType;

/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2020/3/23 0023
 * Time: 17:42
 */
class ArticleController extends Controller
{
    protected function index()
    {
        $news_center = ArticleInfo::query()
            ->where('id', '=', 1)
            ->first();

        $news_center2 = ArticleInfo::query()
            ->where('id', '=', 35)
            ->orderBy('id', 'desc')
            ->first();

        $group_news1 = ArticleInfo::query()->where('type', '=', NewsType::GROUP_NEWS)
            ->orderBy('id', 'asc')
            ->limit(3)->get();

        $group_news2 = ArticleInfo::query()->whereIn('type', [NewsType::GROUP_NEWS,NewsType::ALERT])
            ->whereNotIn('id', $group_news1->pluck('id')->toArray())
            ->orderBy('id', 'asc')
            ->limit(2)->get();
//dd($group_news2->toArray());

        $item_trends = ArticleInfo::query()->where('type', '=', NewsType::ITEM_TRENDS)
            ->orderBy('id', 'asc')
            ->limit(2)->get();
        $item_trends2 = ArticleInfo::query()->where('type', '=', NewsType::ITEM_TRENDS)
            ->whereNotIn('id', $item_trends->pluck('id')->toArray())
            ->orderBy('id', 'asc')
            ->limit(3)->get();
        return view('index.news.index', ['news_center' => $news_center,
            'news_center2' => $news_center2,
            'group_news' => $group_news1, 'group_news2' => $group_news2, 'item_trends' => $item_trends,'item_trends2'=>$item_trends2]);
    }

    public function info(Request $request)
    {

        $type = $request->get('type');
        $id = $request->post('id');
        $res =  ArticleInfo::where('id','=',$id)->increment('browse');

        $data = ArticleInfo::query()->where('type', '=', $type)
            ->where('id','<>',$id)
            ->orderBy('release_time','desc')
            ->limit(6)
            ->get();
        $info = ArticleInfo::query()
            ->where('id', $id)->first();


        return view('index.news.article_info', compact('info'))->with(compact('data'))->with(compact('type'));
    }

    public function article_list(Request $request)
    {
        $search = $request->post('tag');
        $page = $request->get('page');
        $type = $request->get('type') ;
        $data = ArticleInfo::query()
            ->when($type,function($query) use ($type){
                $query->where('type','=',$type);
            })
            ->when($search,function($query) use ($search){
                $query->where('title','like','%'.$search.'%');
            })
            ->orderBy('release_time','desc')
            ->paginate(12, ['*'], 'page', $page);

        return view('index.news.article_list',compact('data'))->with(compact('type'));
    }

    function getIp()
    {
        if ($_SERVER["HTTP_CLIENT_IP"] && strcasecmp($_SERVER["HTTP_CLIENT_IP"], "unknown")) {
            $ip = $_SERVER["HTTP_CLIENT_IP"];
        } else {
            if ($_SERVER["HTTP_X_FORWARDED_FOR"] && strcasecmp($_SERVER["HTTP_X_FORWARDED_FOR"], "unknown")) {
                $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
            } else {
                if ($_SERVER["REMOTE_ADDR"] && strcasecmp($_SERVER["REMOTE_ADDR"], "unknown")) {
                    $ip = $_SERVER["REMOTE_ADDR"];
                } else {
                    if (isset ($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'],
                            "unknown")
                    ) {
                        $ip = $_SERVER['REMOTE_ADDR'];
                    } else {
                        $ip = "unknown";
                    }
                }
            }
        }
        return ($ip);
    }
}